/**
 * about:bookmarkshome handler
 * (c) 2005 Myen adapted by Jeroen Groenenboom and jean-bernard marcon
 * based on kitchensink, Mozilla's nsAboutRedirector.cpp and related files
 * License: MPL
 */

function aboutBookmarkshome(){}

aboutBookmarkshome.prototype = {

    get K_URI() { 
	var bmhDynamic = true;
	try {
	    var branch = Components.classes["@mozilla.org/preferences-service;1"]
		.getService( Components.interfaces.nsIPrefService )
		.getBranch( "bookmarkshome." );
	    // if pref says static, check if hoverDiv style has been added
	    if(( ! branch.getBoolPref( "dynamic" )) &&  
		    ( branch.getCharPref( "addon" ) == "addon 140" )) {
		// check if static page exists
		var  bmhStaticLoc = Components.classes["@mozilla.org/network/standard-url;1"]
		    .createInstance( Components.interfaces.nsIURL );
		bmhStaticLoc.spec = "chrome://bookmarkshome/content/bmhSaved.html";
		var  chromeReg = Components.classes["@mozilla.org/chrome/chrome-registry;1"]
		    .getService( Components.interfaces.nsIChromeRegistry );
		// convert chrome url to file url 
		var fileURL = chromeReg.convertChromeURL( bmhStaticLoc );
		if( fileURL instanceof Components.interfaces.nsIURI ) {
		    // deerpark
		    fileURL = fileURL.spec;
		}
		// get file from url
		var bmhFile = Components.classes["@mozilla.org/network/protocol;1?name=file"]
		    .createInstance( Components.interfaces.nsIFileProtocolHandler )
		    .getFileFromURLSpec( fileURL );
		if( bmhFile.exists() ) {
		    bmhDynamic = false;
		}
	    }
	}
	catch( e ) {
	    dump( e );
	}

	if( bmhDynamic ) { 
	    return "chrome://bookmarkshome/content/bookmarksHome.html"; 
	}
	else {
	    return "chrome://bookmarkshome/content/bmhSaved.html";
	}
    },

    /* nsIAboutModule */
    /* nsIChannel newChannel(in nsIURI aURI); */
newChannel: function ( aURI ) {
		var ex;
		// sanity check
		aURI = aURI.QueryInterface( Components.interfaces['nsIURI'] );

		var ioService = 
		    Components.classes['@mozilla.org/network/io-service;1']
		    .getService( Components.interfaces['nsIIOService'] );
		var tempChannel =
		    ioService.newChannel( this.K_URI, null, null );

		try {
		    tempChannel.setOriginalURI(aURI);
		} catch ( ex ) {
		    // exception ignored
		}

		// XXX Mook: I have tested this, and the resulting channel does not appear
		// to have chrome privileges.  

		return tempChannel;
	    },

	    /* nsISupports */
QueryInterface: function (aIID) {
		    var interfaces = [
			'nsISupports',
		    'nsIAboutModule'
			];
		    for( var index in interfaces ) {
			if ( aIID.equals( Components.interfaces[interfaces[index]] ))
			    return this;
		    }
		    throw this.C_RESULTS['NS_ERROR_NO_INTERFACE'];
		}
}
